/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.registry;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;


/**
 * TODO documentation
 *
 * @author rlogiacco
 */
public interface DeduplicationStrategy {

	/*#net.smartlab.web.registry.DeduplicationCode code*/
	/**
	 * This method is used to compute a pseudo <code>Hash Code</code> to
	 * find out if similar entries exists into the database allowing to drop
	 * duplicated entries and mantaining the archive cleaner. The algorithm used
	 * to compute the deduplication code should be consistent and based on
	 * business rules, here is provided a basic implementation useful only for
	 * simple and basic business. This method should be called before any
	 * insertion or update.
	 * @param entity
	 * @uml.property  name="deduplicationCode" default="new net.smartlab.web.registry.DeduplicationCode()"
	 * @uml.associationEnd  multiplicity="(1 1)" aggregation="shared" inverse="deduplicationStrategy:net.smartlab.registry.DeduplicationCode"
	 * @return
	 */
	public DeduplicationCode digest(Entity entity);

	/**
	 * TODO documentation
	 *
	 * @param criteria
	 * @param code
	 * @return
	 * @throws HibernateException
	 */
	public Criteria getCriteria(Criteria criteria, DeduplicationCode code) throws HibernateException;
}
