/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
package net.smartlab.web.registry;

import java.util.Iterator;
import java.util.NoSuchElementException;

/**
 * The class represents the registry <tt>EntityHelper</tt> to obtain
 * necessary methods. 
 * 
 * @author gperrone
 */
public class EntityHelper extends EntryHelper {

	/**
     * Constructs an empty EntityHelper to be used by reflection
     */
	public EntityHelper(){
		
	}
	/**
	 * @TODO documentation
	 * @param entry
	 */
	protected EntityHelper(Entry entry) {
		super(entry);
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public boolean isEmailReachable() {
		return this.getEmailAddress() != null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public boolean isMailReachable() {
		return this.getMailAddress() != null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public boolean isWebReachable() {
		return this.getWebAddress() != null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public boolean isMessengerReachable() {
		return this.getMessengerAddress() != null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public boolean isMobileReachable() {
		return this.getMobileAddress() != null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public boolean isHomeReachable() {
		return this.getHomeAddress() != null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public boolean isOfficeReachable() {
		return this.getOfficeAddress() != null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public boolean isFaxReachable() {
		return this.getFaxAddress() != null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public Address getEmailAddress() {
		try {
			return ((Entity)this.getEntry()).getAddress(EmailAddress.class);
		} catch (NoSuchElementException nse) {
			return null;
		}
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public Address getFaxAddress() {
		if (((Entity)this.getEntry()).getAddresses(PhoneAddress.class) != null) {
			Iterator iter = ((Entity)this.getEntry()).getAddresses(PhoneAddress.class).iterator();
			while (iter.hasNext()) {
				PhoneAddress address = (PhoneAddress)iter.next();
				if (address.getType().getId() == PhoneAddress.Type.FAX.getId()) {
					return address;
				}
			}
		}
		return null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public Address getHomeAddress() {
		if (((Entity)this.getEntry()).getAddresses(PhoneAddress.class) != null) {
			Iterator iter = ((Entity)this.getEntry()).getAddresses(PhoneAddress.class).iterator();
			while (iter.hasNext()) {
				PhoneAddress address = (PhoneAddress)iter.next();
				if (address.getType().getId() == PhoneAddress.Type.HOME.getId()) {
					return address;
				}
			}
		}
		return null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public Address getMailAddress() {
		try {
			return ((Entity)this.getEntry()).getAddress(MailAddress.class);
		} catch (NoSuchElementException nse) {
			return null;
		}
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public Address getMessengerAddress() {
		try {
			return ((Entity)this.getEntry()).getAddress(MessengerAddress.class);
		} catch (NoSuchElementException nse) {
			return null;
		}
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public Address getMobileAddress() {
		if (((Entity)this.getEntry()).getAddresses(PhoneAddress.class) != null) {
			Iterator iter = ((Entity)this.getEntry()).getAddresses(PhoneAddress.class).iterator();
			while (iter.hasNext()) {
				PhoneAddress address = (PhoneAddress)iter.next();
				if (address.getType().getId() == PhoneAddress.Type.MOBILE.getId()) {
					return address;
				}
			}
		}
		return null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public Address getOfficeAddress() {
		if (((Entity)this.getEntry()).getAddresses(PhoneAddress.class) != null) {
			Iterator iter = ((Entity)this.getEntry()).getAddresses(PhoneAddress.class).iterator();
			while (iter.hasNext()) {
				PhoneAddress address = (PhoneAddress)iter.next();
				if (address.getType().getId() == PhoneAddress.Type.OFFICE.getId()) {
					return address;
				}
			}
		}
		return null;
	}

	/**
	 * TODO documentation
	 * 
	 * @return
	 */
	public Address getWebAddress() {
		try {
			return ((Entity)this.getEntry()).getAddress(WebAddress.class);
		} catch (NoSuchElementException nse) {
			return null;
		}
	}
}
